unit hiZLIB;

interface

{$I share.inc}

uses Kol,Share,KolZLib,Debug;

type
  THIZLIB = class(TDebug)
   private
    procedure _OnProgress(Sender: PStream);
   public
    _data_Stream:THI_Event;
    _event_onStream:THI_Event;

    procedure _work_doCompress(var _Data:TData; Index:word);
    procedure _work_doDeCompress(var _Data:TData; Index:word);
  end;

implementation

procedure THIZLIB._OnProgress;
begin

end;

procedure THIZLIB._work_doCompress;
var
  st,dest,zip:PStream;
  s:integer;
begin
   st := ReadStream(_data,_data_Stream,nil);
   if st <> nil then
    begin
     dest := NewMemoryStream;
     st.Position := 0;

     s := st.Size;
     dest.Write(s,4);
     if not NewZLibCStream(zip,clMax,dest,nil) then
      ;
     Stream2Stream(zip,st,st.Size);
     zip.Free;
     dest.Position := 0;

     _hi_OnEvent(_event_onStream,dest);
     dest.Free;
    end;
end;

procedure THIZLIB._work_doDeCompress;
var st,dest,new_st:PStream;
    s:integer;
begin
   st := ReadStream(_data,_data_Stream,nil);
   if (st <> nil) and (st.size >= 12) then
    begin
     st.Position := 0;
     st.Read(s,4);
     dest := NewMemoryStream;
     if not NewZLibDStream(new_st,st,_OnProgress) then
       ;
     Stream2Stream(dest,new_st,s);
     new_st.Free;
     //dest := new_st;
     dest.Position := 0;

     _hi_OnEvent(_event_onStream,dest);
     dest.Free;
    end;
end;

end.